Index: /branches/multichoice/examples/mapviewer/camera/camera_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/camera/camera_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/camera/camera_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/camera/camera_zoom_layer_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/camera/camera_zoom_layer_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/camera/camera_zoom_layer_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/colorramp/colorramp_geotiff_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/colorramp/colorramp_geotiff_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/colorramp/colorramp_geotiff_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/colorramp/colorramp_netcdf_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/colorramp/colorramp_netcdf_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/colorramp/colorramp_netcdf_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/feature/afr_elas.prj
===================================================================
--- /branches/multichoice/examples/mapviewer/feature/afr_elas.prj	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/feature/afr_elas.prj	(revision 6371)
@@ -0,0 +1,1 @@
+GEOGCS["GCS_WGS_1984",DATUM["D_WGS_1984",SPHEROID["WGS_1984",6378137,298.257223563]],PRIMEM["Greenwich",0],UNIT["Degree",0.017453292519943295]]
Index: /branches/multichoice/examples/mapviewer/feature/feature_layer_26_colors.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/feature/feature_layer_26_colors.tcl	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/feature/feature_layer_26_colors.tcl	(revision 6371)
@@ -0,0 +1,218 @@
+# This example demonstrates a problem that used to exist where
+# sending too much data along with the command to the server
+# would hit the command length limit. Data like stylesheets
+# and selector information should now be sent over the data channel.
+
+package require Tk
+package require Rappture
+package require RapptureGUI
+
+set colors25 {
+FF0000FF
+FF2A00FF
+FF5500FF
+FF8000FF
+FFAA00FF
+FFD500FF
+FFFF00FF
+D5FF00FF
+AAFF00FF
+80FF00FF
+55FF00FF
+2BFF00FF
+00FF00FF
+00FF2AFF
+00FF55FF
+00FF80FF
+00FFAAFF
+00FFD4FF
+00FFFFFF
+00D4FFFF
+00AAFFFF
+0080FFFF
+0055FFFF
+002BFFFF
+0000FFFF
+}
+
+set cutoffs25 {
+-141000
+5.65e+06
+1.13e+07
+1.70e+07
+2.26e+07
+2.83e+07
+3.39e+07
+3.96e+07
+4.52e+07
+5.09e+07
+5.65e+07
+6.22e+07
+6.79e+07
+7.35e+07
+7.92e+07
+8.48e+07
+9.05e+07
+9.61e+07
+1.02e+08
+1.07e+08
+1.13e+08
+1.19e+08
+1.24e+08
+1.30e+08
+1.36e+08
+1.41e+08
+}
+
+set colors26 {
+FF0000FF
+FF2900FF
+FF5200FF
+FF7A00FF
+FFA300FF
+FFCC00FF
+FFF500FF
+E0FF00FF
+B8FF00FF
+8FFF00FF
+66FF00FF
+3DFF00FF
+14FF00FF
+00FF14FF
+00FF3DFF
+00FF66FF
+00FF8FFF
+00FFB8FF
+00FFE0FF
+00F5FFFF
+00CCFFFF
+00A3FFFF
+007AFFFF
+0052FFFF
+0029FFFF
+0000FFFF
+}
+
+set cutoffs26 {
+-141000
+5.44e+06
+1.09e+07
+1.63e+07
+2.17e+07
+2.72e+07
+3.26e+07
+3.81e+07
+4.35e+07
+4.89e+07
+5.44e+07
+5.98e+07
+6.52e+07
+7.07e+07
+7.61e+07
+8.16e+07
+8.70e+07
+9.24e+07
+9.79e+07
+1.03e+08
+1.09e+08
+1.14e+08
+1.20e+08
+1.25e+08
+1.30e+08
+1.36e+08
+1.41e+08
+}
+
+
+proc generateStyleSheet {colors} {
+
+    set style_t {
+      sID {
+        fill: #COLOR;
+        stroke: #000000ff;
+        stroke-width: 3;
+        altitude-clamping: terrain-drape;
+      }
+    }
+    set stylesheet ""
+    for {set i 0} {$i < [llength $colors]} {incr i} {
+        set s $style_t
+        regsub ID $s $i s
+        regsub COLOR $s [lindex $colors $i] s
+        append stylesheet $s
+    }
+
+    return $stylesheet
+}
+
+proc generateSelectors {cutoffs} {
+    set selectors ""
+    set numSelectors [llength $cutoffs]
+    for {set i 0} {$i < $numSelectors-1} {incr i} {
+       set lower [lindex $cutoffs $i]
+       set upper [lindex $cutoffs [expr $i+1]]
+       lappend selectors [list id $i style s$i query "POP2005 >= $lower and POP2005 < $upper"]
+    }
+
+    return $selectors
+}
+
+
+
+Rappture::resources::load
+
+set commondir [file join [file dirname [info script]] .. common]
+source [file join $commondir geovis_settings.tcl]
+
+set width 400
+set height 300
+wm geometry . ${width}x${height}
+update
+
+set mapviewer [Rappture::MapViewer .g]
+
+pack .g -expand yes -fill both
+
+
+# Create a map object
+set map [Rappture::Map #auto]
+
+# Parameters for feature layer
+array set ogrParams {
+    url {file:///data/mygeohub/tools/landuse/afr_countries.shp}
+}
+array set countries {
+    label   "Countries"
+    opacity 1.0
+}
+
+set stylesheet [generateStyleSheet $colors25]
+set selectors [generateSelectors $cutoffs25]
+
+# Configure layers
+$map addLayer feature \
+    pop25 [array get countries] \
+    ogr [array get ogrParams] \
+    $stylesheet "" $selectors
+
+
+# Add map to viewer
+$mapviewer add $map
+$mapviewer scale $map
+
+
+after 5000 {
+    $map deleteLayer "pop25"
+
+    set stylesheet [generateStyleSheet $colors26]
+    set selectors [generateSelectors $cutoffs26]
+
+    # Configure layers
+    $map addLayer feature \
+        pop26 [array get countries] \
+        ogr [array get ogrParams] \
+        $stylesheet "" $selectors
+
+    $mapviewer refresh
+    puts "updating layer"
+}
Index: /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_callback.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_callback.tcl	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_callback.tcl	(revision 6371)
@@ -0,0 +1,140 @@
+package require Tk
+package require Rappture
+package require RapptureGUI
+
+proc handleSelect {option {args ""}} {
+    global selectedFeatures
+
+    switch $option {
+        "annotation" {
+            # User clicked a map annotation (not a feature) like a user-added pin, etc.
+         }
+        "clear" {
+            # Clear any previous selection, user clicked on background where there is no feature
+            # No args
+            set selectedFeatures ""
+        }
+        "feature" {
+            # args: op featureIDList layerName
+            foreach {op featureIdList layerName} $args break
+
+            puts "select feature $op:\tfeatureIDList=\"$featureIdList\"\tlayerName=\"$layerName\""
+
+            # strip off the mapId from the layerName
+            regexp {([^-]*)-(.*)} $layerName matched mapId layerName
+
+            switch $op {
+                "add" {
+                    set selectedFeatures [concat $selectedFeatures $featureIdList]
+                }
+                "set" {
+                    set selectedFeatures $featureIdList
+                }
+                "remove" {
+                    foreach i $featureIdList {
+                        set id [lsearch -exact $selectedFeatures $i]
+                        if {$id > 0} {
+                            set selectedFeatures [lreplace $selectedFeatures $id $id]
+                        }
+                    }
+                }
+            }
+            updateHighlightedFeatures $layerName $selectedFeatures
+        }
+    }
+}
+
+proc updateHighlightedFeatures {layerName selectedFeatures} {
+    global map
+    global mapviewer
+    global selector2
+
+    $map deleteSelector $layerName $selector2(id)
+    set selector2(query) [concat "FID IN (" [join $selectedFeatures ","] ")"]
+    $map addSelector $layerName $selector2(id) [array get selector2]
+
+    puts "refreshing mapviewer"
+    $mapviewer refresh
+}
+
+
+Rappture::resources::load
+
+set commondir [file join [file dirname [info script]] .. common]
+source [file join $commondir geovis_settings.tcl]
+
+set width 400
+set height 300
+wm geometry . ${width}x${height}
+update
+
+set mapviewer [Rappture::MapViewer .g]
+
+pack .g -expand yes -fill both
+
+
+# Parameters for feature layer
+array set ogrParams {
+    url {local://afr_elas.shp}
+}
+array set countries {
+    label   "Countries"
+    opacity 1.0
+}
+set stylesheet {
+  s1 {
+    fill: #98AFC7;
+    stroke: #000000;
+    stroke-width: 3;
+    altitude-clamping: terrain-drape;
+  }
+  s2 {
+    fill: #00FFFF;
+    stroke: #000000;
+    stroke-width: 3;
+    altitude-clamping: terrain-drape;
+  }
+}
+array set selector1 {
+    id    1
+    style s1
+    query "POP2005 >= 0"
+}
+array set selector2 {
+    id    2
+    style s2
+    query "FID IN (0,1)"
+}
+set numSelectors 2
+for {set i 1} {$i <= $numSelectors} {incr i} {
+   lappend selectors [array get selector$i]
+}
+
+# Track of which feature ids have been selected
+set selectedFeatures "0 1"
+
+# Create a map object
+set map [Rappture::Map #auto]
+
+# Configure layers
+set layerId 0
+$map addLayer feature \
+    countries$layerId [array get countries] \
+    ogr [array get ogrParams] \
+    $stylesheet "" $selectors
+
+# Add map to viewer
+$mapviewer add $map
+$mapviewer scale $map
+
+$mapviewer setSelectCallback "handleSelect"
+
+after 2000 {
+    $mapviewer camera zoom layer $map countries$layerId
+}
+
+after 5000 {
+    # simulating selecting features from outside of the map
+    $mapviewer select feature add "44 48 43 21" $map-countries$layerId
+    puts "select feature add ..."
+}
Index: /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_new_layer.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_new_layer.tcl	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_new_layer.tcl	(revision 6371)
@@ -0,0 +1,221 @@
+package require Tk
+package require Rappture
+package require RapptureGUI
+
+set colors23 {
+    FF0000FF
+    FF8000FF
+    FFAA00FF
+    FFD500FF
+    FFFF00FF
+    D5FF00FF
+    AAFF00FF
+    80FF00FF
+    55FF00FF
+    2BFF00FF
+    00FF00FF
+    00FF2AFF
+    00FF55FF
+    00FF80FF
+    00FFAAFF
+    00FFD4FF
+    00FFFFFF
+    00D4FFFF
+    00AAFFFF
+    0080FFFF
+    0055FFFF
+    002BFFFF
+    0000FFFF
+}
+
+set cutoffs24 {
+    0.019100
+    0.067600
+    0.083600
+    0.099600
+    0.116000
+    0.132000
+    0.148000
+    0.164000
+    0.180000
+    0.196000
+    0.212000
+    0.228000
+    0.244000
+    0.260000
+    0.276000
+    0.292000
+    0.308000
+    0.324000
+    0.340000
+    0.356000
+    0.372000
+    0.388000
+    0.404000
+    0.420000
+}
+
+
+proc handleSelect {option {args ""}} {
+    global selectedFeatures
+    switch $option {
+        "annotation" {
+            # User clicked a map annotation (not a feature) like a user-added pin, etc.
+         }
+        "clear" {
+            # Clear any previous selection, user clicked on background where there is no feature
+            # No args
+        }
+        "feature" {
+            # args: op featureIDList layerName
+            foreach {op featureIdList layerName} $args break
+            switch $op {
+                "add" {
+                }
+                "set" {
+                    foreach {op featureIdList layerName} $args break
+                    lappend selectedFeatures $featureIdList
+                    adjustLayerHighlight $op $selectedFeatures $layerName
+                }
+                "remove" {
+                }
+            }
+        }
+    }
+}
+
+
+proc adjustLayerHighlight {option featureIdList layerName} {
+    global map
+    global mapviewer
+    global stylesheet
+    global cutoffs24
+    set selectors [generateSelectors $cutoffs24 $featureIdList]
+    $map deleteLayer "countries"
+    set layerName "countries"
+    addCountryLayer $map $layerName $stylesheet $selectors
+    $mapviewer refresh
+}
+
+proc generateStyleSheet {colors} {
+
+    set style_t {
+      sID {
+        fill: #COLOR;
+        stroke: #000000ff;
+        stroke-width: 3;
+        altitude-clamping: terrain-drape;
+      }
+    }
+    set stylesheet ""
+    for {set i 0} {$i < [llength $colors]} {incr i} {
+        # append stylesheet "\n" [string map {ID $i COLOR [lindex $colors $i]} $style_t]
+        set s $style_t
+        regsub ID $s $i s
+        regsub COLOR $s [lindex $colors $i] s
+        append stylesheet $s
+    }
+
+    # add a color for fields marked as NA or -1 where there was no data
+    append stylesheet [string map {ID NA COLOR f2f2f2ff} $style_t]
+
+    # add a color for selected fields
+    append stylesheet [string map {ID SE COLOR 000000FF} $style_t]
+
+    return $stylesheet
+}
+
+proc generateSelectors {cutoffs {featureIdList {}}} {
+    set selectors ""
+    set numSelectors [llength $cutoffs]
+    for {set i 0} {$i < $numSelectors-1} {incr i} {
+       set lower [lindex $cutoffs $i]
+       set upper [lindex $cutoffs [expr $i+1]]
+       lappend selectors [list id $i style s$i query "elas >= $lower and elas < $upper"]
+    }
+
+    # add a selector for fields marked as NA or -1 where there was no data
+    incr i
+    lappend selectors [list id $i style sNA query "elas = -1"]
+
+    # add a selector for selected fields
+    incr i
+    lappend selectors [list id $i style sSE query "FID IN ([join $featureIdList ","])"]
+
+    return $selectors
+}
+
+proc addCountryLayer {map layerName stylesheet selectors} {
+    # Parameters for feature layer
+    array set ogrParams {
+        url {local://afr_elas.shp}
+    }
+    array set countries {
+        label   "Countries"
+        opacity 1.0
+    }
+
+    # Configure layers
+    $map addLayer feature \
+        $layerName [array get countries] \
+        ogr [array get ogrParams] \
+        $stylesheet "" $selectors
+}
+
+
+
+Rappture::resources::load
+
+set commondir [file join [file dirname [info script]] .. common]
+source [file join $commondir geovis_settings.tcl]
+
+set width 400
+set height 300
+wm geometry . ${width}x${height}
+update
+
+set mapviewer [Rappture::MapViewer .g]
+
+pack .g -expand yes -fill both
+
+# setup a global variable to accumulate selected features
+set selectedFeatures {0 1 2 3 4}
+
+set stylesheet [generateStyleSheet $colors23]
+set selectors [generateSelectors $cutoffs24 $selectedFeatures]
+
+# Create a map object
+set map [Rappture::Map #auto]
+
+set layerName "countries"
+addCountryLayer $map $layerName $stylesheet $selectors
+
+# Configure the placard
+set placardAttributes [list \
+    name "Country Name" \
+    ISO3 "Country Code" \
+    elas "Elasticity" \
+]
+set placardStyle {
+    fill: #B6B6B688;
+    text-fill: #000000;
+    text-size: 12.0;
+}
+set placardPadding 5
+$map setPlacardConfig countries \
+    $placardAttributes \
+    $placardStyle \
+    $placardPadding
+
+
+# Add map to viewer
+$mapviewer add $map
+$mapviewer scale $map
+
+# setup feature callback
+$mapviewer setSelectCallback "handleSelect"
+
+after 2000 {
+    $mapviewer camera zoom layer $map $layerName
+}
+
Index: /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_updated_layer.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_updated_layer.tcl	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/feature/feature_multiple_selection_by_updated_layer.tcl	(revision 6371)
@@ -0,0 +1,125 @@
+package require Tk
+package require Rappture
+package require RapptureGUI
+
+Rappture::resources::load
+
+set commondir [file join [file dirname [info script]] .. common]
+source [file join $commondir geovis_settings.tcl]
+
+set width 400
+set height 300
+wm geometry . ${width}x${height}
+update
+
+set mapviewer [Rappture::MapViewer .g]
+
+pack .g -expand yes -fill both
+
+
+# Parameters for feature layer
+array set ogrParams {
+    url {local://afr_elas.shp}
+}
+array set countries {
+    label   "Countries"
+    opacity 1.0
+}
+set stylesheet {
+  s1 {
+    fill: #98AFC7;
+    stroke: #000000;
+    stroke-width: 3;
+    altitude-clamping: terrain-drape;
+  }
+  s2 {
+    fill: #00FFFF;
+    stroke: #000000;
+    stroke-width: 3;
+    altitude-clamping: terrain-drape;
+  }
+}
+array set selector1 {
+    id    1
+    style s1
+    query "POP2005 >= 0"
+}
+array set selector2 {
+    id    2
+    style s2
+    query "FID IN (0,1)"
+}
+set numSelectors 2
+for {set i 1} {$i <= $numSelectors} {incr i} {
+   lappend selectors [array get selector$i]
+}
+
+# Create a map object
+set map [Rappture::Map #auto]
+
+# Configure layers
+set layerId 0
+$map addLayer feature \
+    countries$layerId [array get countries] \
+    ogr [array get ogrParams] \
+    $stylesheet "" $selectors
+
+# Add map to viewer
+$mapviewer add $map
+$mapviewer scale $map
+
+after 2000 {
+    $mapviewer camera zoom layer $map countries$layerId
+}
+
+after 5000 {
+    puts "updating layer: reusing layer name (delete/add)"
+
+    $map deleteLayer countries$layerId
+
+    set selector2(query) "FID IN (0,1,2,3,4,5,6,7,8,12,15,44)"
+    set selectors ""
+    for {set i 1} {$i <= $numSelectors} {incr i} {
+       lappend selectors [array get selector$i]
+    }
+
+    $map addLayer feature \
+        countries$layerId [array get countries] \
+        ogr [array get ogrParams] \
+        $stylesheet "" $selectors
+
+    puts "refreshing mapviewer"
+    $mapviewer refresh
+}
+
+
+after 10000 {
+    puts "updating layer: new layer name"
+
+    set selector2(query) "FID IN (7,8,12,15,44)"
+    set selectors ""
+    for {set i 1} {$i <= $numSelectors} {incr i} {
+       lappend selectors [array get selector$i]
+    }
+
+    incr layerId
+    $map addLayer feature \
+        countries$layerId [array get countries] \
+        ogr [array get ogrParams] \
+        $stylesheet "" $selectors
+
+    puts "refreshing mapviewer"
+    $mapviewer refresh
+}
+
+
+after 15000 {
+    puts "updating layer selectors using addSelector/deleteSelector"
+
+    $map deleteSelector countries$layerId $selector2(id)
+    set selector2(query) "FID IN (33,34,35,36,37,38,39,4,48,21,43)"
+    $map addSelector countries$layerId $selector2(id) [array get selector2]
+
+    puts "refreshing mapviewer"
+    $mapviewer refresh
+}
Index: /branches/multichoice/examples/mapviewer/feature/feature_selector_query.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/feature/feature_selector_query.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/feature/feature_selector_query.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
@@ -27,5 +28,5 @@
 # Parameters for feature layer
 array set ogrParams {
-    url {local://afr_countries.shp}
+    url {local://afr_elas.shp}
 }
 array set countries {
Index: /branches/multichoice/examples/mapviewer/gdal/gdal_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/gdal/gdal_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/gdal/gdal_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/layers/add_remove_layers.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/layers/add_remove_layers.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/layers/add_remove_layers.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
@@ -79,6 +80,5 @@
 
     # Update map
-    $mapviewer delete
-    $mapviewer add $map
+    $mapviewer refresh
     puts stderr "Deleted OSM Layer, Added colorramp"
 }
@@ -94,6 +94,5 @@
 
     # Update map
-    $mapviewer delete
-    $mapviewer add $map
+    $mapviewer refresh
     puts stderr "Deleted colorramp Layer, Added line layer"
 }
@@ -110,6 +109,5 @@
 
     # Update map
-    $mapviewer delete
-    $mapviewer add $map
+    $mapviewer refresh
     puts stderr "Deleted line Layer, Added OSM layer"
 }
@@ -122,6 +120,5 @@
 
     # Update map
-    $mapviewer delete
-    $mapviewer add $map
+    $mapviewer refresh
     puts stderr "Added colorramp layer"
 }
@@ -134,6 +131,5 @@
 
     # Update map
-    $mapviewer delete
-    $mapviewer add $map
+    $mapviewer refresh
     puts stderr "Added line layer"
 }
Index: /branches/multichoice/examples/mapviewer/layers/remove_single_layer.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/layers/remove_single_layer.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/layers/remove_single_layer.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
@@ -84,6 +85,5 @@
 
     # Update the map
-    $mapviewer delete
-    $mapviewer add $map
+    $mapviewer refresh
 }
 
Index: /branches/multichoice/examples/mapviewer/layers/repeated_layer_names.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/layers/repeated_layer_names.tcl	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/layers/repeated_layer_names.tcl	(revision 6371)
@@ -0,0 +1,86 @@
+package require Rappture
+package require RapptureGUI
+
+Rappture::resources::load
+
+set commondir [file join [file dirname [info script]] .. common]
+source [file join $commondir geovis_settings.tcl]
+
+set width 400
+set height 300
+wm geometry . ${width}x${height}
+update
+
+set mapviewer [Rappture::MapViewer .g]
+
+pack .g -expand yes -fill both
+
+# create xyz layer
+array set xyzParams {
+    url {http://otile[1234].mqcdn.com/tiles/1.0.0/map/{z}/{x}/{y}.jpg}
+}
+array set osm {
+    label "OSM"
+    cache false
+}
+
+# create an feature icon layer from a csv file using the OGR driver
+# the longitude and latitude fields must be named "longitude" and
+# "latitude" respectively
+#
+# we add the local:// prefix to tell the map viewer widget that
+# the file exists locally and needs to be transferred to the
+# geovis server.
+# set path "local://coord.csv"
+set path "local://coord1.csv"
+array set ogrParams1 [subst {
+    url {$path}
+}]
+array set iconParams1 {
+    label  "CSV data 1"
+    description "using OGR data provider to load data from a CSV file"
+    style "-icon pin3"
+}
+
+set path "local://coord2.csv"
+array set ogrParams2 [subst {
+    url {$path}
+}]
+array set iconParams2 {
+    label  "CSV data 2"
+    description "using OGR data provider to load data from a CSV file"
+    style "-icon pin7"
+}
+
+# create a map object
+set map [Rappture::Map #auto]
+
+# add a layer to the map object
+$map addLayer image \
+    osm [array get osm] \
+    xyz [array get xyzParams]
+
+# add csv layer 1 to the map object
+$map addLayer icon \
+    csvdata [array get iconParams1] \
+    ogr [array get ogrParams1]
+
+$mapviewer scale $map
+$mapviewer add $map
+
+
+after 5000 {
+    # remove csv layer 1 from the map object
+    $map deleteLayer csvdata
+
+    # add csv layer 2 to the map object
+    # with the same layer name as our previous layer
+    $map addLayer icon \
+        csvdata [array get iconParams2] \
+        ogr [array get ogrParams2]
+
+    # Update map viewer
+    $mapviewer clear
+    $mapviewer add $map
+    puts stderr "Deleted csv layer 1, Added csv layer 2"
+}
Index: /branches/multichoice/examples/mapviewer/ogr/ogr_csv_icon_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/ogr/ogr_csv_icon_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/ogr/ogr_csv_icon_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
@@ -25,5 +26,5 @@
 }
 
-# create an feature point layer from a csv file using the OGR driver
+# create a feature icon layer from a csv file using the OGR driver
 # the longitude and latitude fields must be named "longitude" and
 # "latitude" respectively
Index: /branches/multichoice/examples/mapviewer/ogr/ogr_csv_points_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/ogr/ogr_csv_points_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/ogr/ogr_csv_points_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/ogr/ogr_csv_to_shp_icon_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/ogr/ogr_csv_to_shp_icon_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/ogr/ogr_csv_to_shp_icon_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/ogr/ogr_shape_line_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/ogr/ogr_shape_line_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/ogr/ogr_shape_line_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/placard/placard_disable_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/placard/placard_disable_example.tcl	(revision 6371)
+++ /branches/multichoice/examples/mapviewer/placard/placard_disable_example.tcl	(revision 6371)
@@ -0,0 +1,78 @@
+package require Tk
+package require Rappture
+package require RapptureGUI
+
+Rappture::resources::load
+
+set commondir [file join [file dirname [info script]] .. common]
+source [file join $commondir geovis_settings.tcl]
+
+set width 400
+set height 300
+wm geometry . ${width}x${height}
+update
+
+set mapviewer [Rappture::MapViewer .g]
+
+pack .g -expand yes -fill both
+
+# create an XYZ world layer
+array set xyzParams {
+    url {http://otile[1234].mqcdn.com/tiles/1.0.0/map/{z}/{x}/{y}.jpg}
+}
+array set osm {
+    label "OSM Map"
+    description "MapQuest OpenStreetMap Street base layer"
+}
+
+# create an feature point layer from a csv file using the OGR driver
+# the longitude and latitude fields must be named "longitude" and
+# "latitude" respectively
+#
+# we add the local:// prefix to tell the map viewer widget that
+# the file exists locally and needs to be transferred to the
+# geovis server.
+# set path "local://[file join [file dirname [info script]] coord.csv]"
+set path "local://station_clean.csv"
+array set ogrParams [subst {
+    url {$path}
+}]
+array set stations {
+    label "CSV data"
+    description "using OGR data provider to load data from a CSV file"
+}
+array set placardAttributes {
+    latitude Lat
+    longitude Lon
+}
+set placardStyle {
+    fill: #B6B6B688;
+    text-fill: #000000;
+    text-size: 12.0;
+}
+set placardPadding 5
+
+# create a map object
+set map [Rappture::Map #auto]
+
+# add all layers to the map object
+$map addLayer image \
+    osm [array get osm] \
+    xyz [array get xyzParams]
+$map addLayer icon \
+    stations [array get stations] \
+    ogr [array get ogrParams]
+$map setPlacardConfig stations \
+    [array get placardAttributes] \
+    $placardStyle \
+    $placardPadding
+
+# add a map to the vis client
+$mapviewer scale $map
+$mapviewer add $map
+
+# Make sure the MapViewer rebuilds the map
+$mapviewer refresh
+
+# disable the placard for the "stations" layer of $map
+$mapviewer placard enable off "$map-stations"
Index: /branches/multichoice/examples/mapviewer/placard/placard_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/placard/placard_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/placard/placard_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
